#ifndef CHARACTE_H
#define CHARACTE_H

#pragma warn -8012 // Borland C++ 5.5.1 for Win32
#pragma warn -8057

#define ARRAY_SIZE 48
#define BEFORE_SIZE 2
#define BREAK_TIME 25
#define BUFFER_SIZE 384
#define C_ARRAY_SIZE 64
#define COLON_SIZE 1
#define COMMON_SPACE_SIZE 4
#define COMPLEMENTARY '1'
#define DATE_LINE 9
#define DATE_SIZE 8
#define FILE_NAME_SIZE 256
#define GAP_C ' '
#define GAP_SIZE 1
#define HOURS_MINUTES_SECONDS_SIZE 8
#define HOURS_MINUTES_SIZE 5
#define ID_SIZE 8
#define KANJI_SIZE 2
#define PERIOD 30
#define MAIN_BUFFER_SIZE 4224
#define MARK_C '^'
#define MARK_INDEX 5
#define MARK_SIZE 1
#define MARKED_SPACE_SIZE 7
#define NON_DATE_LINE 0
#define NOT_FOUND -1
#define RAW_BUFFER_SIZE 128
#define REPEATED_POST 7
#define SERIAL_TEXT "serial.txt"
#define SLASH_MONTH_SLASH_SIZE 4
#define SPACE_SIZE 2
#define SPACE_WIDTH 11
#define TABULATE_TEXT "tabulate.txt"
#define TEXT_FILE ".txt"
#define TOKOBI_SIZE 6
#define TWELVE_MONTHS 12
#define WHO "who"
#define WHO_TEXT "who.txt"
#define WIDE_SPACE "           "
#define YEAR_SLASH_SIZE 5
#include <fstream>
#include <iostream>
#include <sstream>
#include <string>
#include <time.h>

enum LINE_1 {FA, TR, ER, ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT, TOO_FEW_GAPS, MINILOTO, LOTO6, LOTO7, BINGO5, TOO_FEW_SLASHES, TOO_SHORT_LINE};

class Characterizable {
protected:
    int lineLength;
    std::string error, head, line, no_error, PUNCTUATION, tail;
    std::string weekdays[7];

    std::string padding(std::string & s);

public:
    std::string pileOfErrorMessages();
    std::string plus(std::string & again);
    virtual ~Characterizable(){}
    virtual int dateLine() = 0;
    virtual std::string anchor_res_no() = 0;
    virtual std::string common() = 0;
    virtual std::string interposed() = 0;
    virtual std::string lotoLine() = 0;
    virtual std::string name_id() = 0;
    virtual std::string rebuild() = 0;
};

class GapID {
    const std::string EMPTY, GAP, ID_COLON, RANNU_TEXT, w0, w1, w2, w3, w4, w5, w6, w7, w8, w9, w10, w11, w12, w13, w14, w15, w16, w17, w18, w19, w20, w21, w22, w23, w24, w25, w26, w27, w28, w29, w30, w31, w32, w33, w34, w35, w36, w37, w38, w39, w40, w41, w42, w43, w44, w45, w46, w47, w48, w49, w50, w51, w52, w53, w54, w55, w56, w57, w58, w59, w60, w61, w62, w63, w64;

    int *random_number;
    int session;
    int two_digit_number[0x100][0x100];
    long table_size;
    std::string error;
    std::string C[C_ARRAY_SIZE];

    bool readRannuText();

public:
    ~GapID() {
        delete random_number;
    }

    long tableSize() const {
        return table_size;
    }

    std::string inquiry() const {
        return error;
    }

    GapID();
    std::string fixedWidth(int n, char c, int width);
    std::string gapID();
};

class Consecutive : public Characterizable {
    bool readyToRebuild;
    const std::string BEFORE, COLON, EMPTY, GAP, ID_COLON, MARK, N_0TO9, TOKOBI, YOBI;
    GapID *d;
    int featuresLength, session;
    std::string date, day, features, gap_id, name, parts, res_no, res_time;

    std::string fixedWidth(int n, char c, int width);

public:
    ~Consecutive() {
        delete d;
    }

    std::string anchor_res_no() {
        return EMPTY;
    }

    std::string common() {
        return EMPTY;
    }

    std::string interposed() {
        return line;
    }

    std::string lotoLine() {
        return EMPTY;
    }

    std::string name_id() {
        return EMPTY;
    }

    int dateLine();
    Consecutive(std::string & l);
    std::string rebuild();
    std::string resTime();
};

class DateFollowed : public Characterizable {
    bool noSplitting, readyToRebuild;
    const std::string ANCHOR, BEFORE, COLON, COMMA, COMMON_SPACE, EMPTY, GAP, ID_COLON, ID_QUESTION, MARK, MARKED_SPACE, N_0TO9, SPACE, TOKOBI, YOBI;
    int featuresLength, NEW_LINE_LENGTH;
    std::string common_res_no, date, day, features, id, name, marked_res_no, NEW_LINE, res_no, time;

    std::string trimmed(std::string & name);

public:
    ~DateFollowed(){}
    std::string lotoLine() {
        return EMPTY;
    }

    DateFollowed(std::string & l);
    DateFollowed(std::string & l, bool n);
    int dateLine();
    std::string anchor_res_no();
    std::string common();
    std::string interposed();
    std::string name_id();
    std::string rebuild();
};

class Gaps : public Characterizable {
    bool axial;
    const std::string EMPTY, GAP, JIKU, QP;
    int a, all, b, f, g, lotoMinusTwo, n, q;
    std::string bigger, smaller;

public:
    virtual ~Gaps(){}
    Gaps(std::string & s, int loto, bool x): EMPTY(""), GAP(" "), JIKU(""), QP("QP") {
        axial = x;
        line = s;
        lotoMinusTwo = loto - 2;

        if(loto == MINILOTO) {
            all = 31;
        } else if(loto == LOTO6) {
            all = 43;
        } else if(loto == LOTO7) {
            all = 37;
        }

    }

    int getAll() const {
        return all;
    }

    int dateLine() {
        return NON_DATE_LINE;
    }

    std::string anchor_res_no() {
        return EMPTY;
    }

    std::string common() {
        return EMPTY;
    }

    std::string interposed() {
        return line;
    }

    std::string name_id() {
        return EMPTY;
    }

    std::string rebuild() {
        return line;
    }

    std::string lotoLine();
};

class MultiLoto : public Characterizable {
	bool axial;
    const std::string EMPTY, JIKU;
    int q;
    std::string head, line, separator;

public:
    ~MultiLoto(){}
    MultiLoto(std::string & l, std::string & s, bool x): EMPTY(""), JIKU("") {
		axial = x;
        line = l;
        separator = s;
    }

    int dateLine() {
		return NON_DATE_LINE;
	}

    std::string anchor_res_no() {
        return EMPTY;
    }

    std::string common() {
        return EMPTY;
    }

    std::string interposed() {
        return line;
    }

    std::string getSeparator() const {
        return separator;
    }

    std::string name_id() {
        return EMPTY;
    }

    std::string rebuild() {
        return line;
    }

    std::string lotoLine();
};

int firstNumber(std::string & sequence);
int stringToInteger(std::string & s);

#endif // CHARACTE_H
