#include "Characte.h"

DateFollowed::DateFollowed(std::string & l): ANCHOR(">>"), BEFORE("F"), COLON(":"), COMMA(","), COMMON_SPACE("    "), EMPTY(""), GAP(" "), ID_COLON(" ID:"), ID_QUESTION("ID:?"), MARK("^"), MARKED_SPACE("     ^ "), N_0TO9("0123456789"), SPACE("@"), TOKOBI("e"), YOBI("ΐ؋y") {
    const std::string MONTH_TIME("/05/ 08:");
    const std::string no("No error");
    const std::string PU(" | ");
    const std::string W0("Sun");
    const std::string W1("Mon");
    const std::string W2("Tue");
    const std::string W3("Wed");
    const std::string W4("Thu");
    const std::string W5("Fri");
    const std::string W6("Sat");
    const std::string YEN("\n");

    common_res_no = EMPTY;
    date = EMPTY;
    day = EMPTY;
    id = EMPTY;
    line = l;
    marked_res_no = EMPTY;
    name = EMPTY;
    NEW_LINE = YEN;
    NEW_LINE_LENGTH = NEW_LINE.length();
    no_error = no;
    noSplitting = false;
    PUNCTUATION = PU;
    readyToRebuild = false;
    res_no = EMPTY;
    time = EMPTY;

    features = MONTH_TIME;
    featuresLength = features.length();

    weekdays[0] = W0;
    weekdays[1] = W1;
    weekdays[2] = W2;
    weekdays[3] = W3;
    weekdays[4] = W4;
    weekdays[5] = W5;
    weekdays[6] = W6;
}

DateFollowed::DateFollowed(std::string & l, bool n): ANCHOR(">>"), BEFORE("F"), COLON(":"), COMMA(","), COMMON_SPACE("    "), EMPTY(""), GAP(" "), ID_COLON(" ID:"), ID_QUESTION("ID:?"), MARK("^"), MARKED_SPACE("     ^ "), N_0TO9("0123456789"), SPACE("@"), TOKOBI("e"), YOBI("ΐ؋y") {
    const std::string MONTH_TIME("/05/ 08:");
    const std::string no("No error");
    const std::string PU(" | ");
    const std::string W0("Sun");
    const std::string W1("Mon");
    const std::string W2("Tue");
    const std::string W3("Wed");
    const std::string W4("Thu");
    const std::string W5("Fri");
    const std::string W6("Sat");
    const std::string YEN("\n");

    common_res_no = EMPTY;
    date = EMPTY;
    day = EMPTY;
    id = EMPTY;
    line = l;
    marked_res_no = EMPTY;
    name = EMPTY;
    NEW_LINE = YEN;
    NEW_LINE_LENGTH = NEW_LINE.length();
    no_error = no;
    noSplitting = n;
    PUNCTUATION = PU;
    readyToRebuild = false;
    res_no = EMPTY;
    time = EMPTY;

    features = MONTH_TIME;
    featuresLength = features.length();

    weekdays[0] = W0;
    weekdays[1] = W1;
    weekdays[2] = W2;
    weekdays[3] = W3;
    weekdays[4] = W4;
    weekdays[5] = W5;
    weekdays[6] = W6;
}

int DateFollowed::dateLine() {
    using namespace std;

    lineLength = line.length();
    if(lineLength < featuresLength) {
        return NON_DATE_LINE;
    }

    string c = line.substr(MARK_INDEX, 1);
    if(c == MARK) {
        return DATE_LINE;
    }

    int p;
    int r[ARRAY_SIZE];

    c = line.substr(0, 1);
    p = N_0TO9.find(c);
    if(p != string::npos) { // res-number
        ;
    } else {
        return NON_DATE_LINE;
    }

    int g = strspn( line.c_str(), "0123456789");
    if(g <= 4) {
        head = line.substr(0, g);
        tail = line.substr(g);
        r[0] = tail.find("/01/");
        r[1] = tail.find("/02/");
        r[2] = tail.find("/03/");
        r[3] = tail.find("/04/");
        r[4] = tail.find("/05/");
        r[5] = tail.find("/06/");
        r[6] = tail.find("/07/");
        r[7] = tail.find("/08/");
        r[8] = tail.find("/09/");
        r[9] = tail.find("/10/");
        r[10] = tail.find("/11/");
        r[11] = tail.find("/12/");
        int k = 0;
        p = tail.length();
        for(int i = 0; i < TWELVE_MONTHS; ++i) {
            if(r[i] != string::npos) {
                p = r[i];
                ++k;
            }

        }

        if(k == 1) { // A slash-month-slash sequence can be found.
            int slash_month_slash = g + p;
            p += SLASH_MONTH_SLASH_SIZE;

// If a colon appears, it shall be removed from the first part of the name.
            c = tail.substr(0, BEFORE_SIZE);
            if(BEFORE == c) { // "F" in Shift_JIS
                name = tail.substr(BEFORE_SIZE, p - BEFORE_SIZE );
            } else {
                c = tail.substr(0, GAP_SIZE);
                if(GAP == c) {
                    c = tail.substr(GAP_SIZE, BEFORE_SIZE);
                    if(BEFORE == c) {
                        const int GAP_BEFORE_SIZE = GAP_SIZE + BEFORE_SIZE; // " F" in Shift_JIS
                        name = tail.substr(GAP_BEFORE_SIZE, p - GAP_BEFORE_SIZE );
                    } else {
                        c = tail.substr(GAP_SIZE, COLON_SIZE);
                        if(COLON == c) {
                            const int GAP_COLON_SIZE = GAP_SIZE + COLON_SIZE; // " :"
                            name = tail.substr(GAP_COLON_SIZE, p - GAP_COLON_SIZE );
                        } else {
                            name = tail.substr(0, p);
                        }

                    }

                } else {
                    name = tail.substr(0, p);
                }

            }

            int n = name.rfind(GAP);
            if(n != string::npos) {
                name = name.substr(0, n);
            }

            tail = tail.substr(p);
            r[0] = tail.find(" 00:");
            r[1] = tail.find(" 01:");
            r[2] = tail.find(" 02:");
            r[3] = tail.find(" 03:");
            r[4] = tail.find(" 04:");
            r[5] = tail.find(" 05:");
            r[6] = tail.find(" 06:");
            r[7] = tail.find(" 07:");
            r[8] = tail.find(" 08:");
            r[9] = tail.find(" 09:");
            r[10] = tail.find(" 10:");
            r[11] = tail.find(" 11:");
            r[12] = tail.find(" 12:");
            r[13] = tail.find(" 13:");
            r[14] = tail.find(" 14:");
            r[15] = tail.find(" 15:");
            r[16] = tail.find(" 16:");
            r[17] = tail.find(" 17:");
            r[18] = tail.find(" 18:");
            r[19] = tail.find(" 19:");
            r[20] = tail.find(" 20:");
            r[21] = tail.find(" 21:");
            r[22] = tail.find(" 22:");
            r[23] = tail.find(" 23:"); // 2ch
            r[24] = tail.find(")00:"); // Open2ch
            r[25] = tail.find(")01:");
            r[26] = tail.find(")02:");
            r[27] = tail.find(")03:");
            r[28] = tail.find(")04:");
            r[29] = tail.find(")05:");
            r[30] = tail.find(")06:");
            r[31] = tail.find(")07:");
            r[32] = tail.find(")08:");
            r[33] = tail.find(")09:");
            r[34] = tail.find(")10:");
            r[35] = tail.find(")11:");
            r[36] = tail.find(")12:");
            r[37] = tail.find(")13:");
            r[38] = tail.find(")14:");
            r[39] = tail.find(")15:");
            r[40] = tail.find(")16:");
            r[41] = tail.find(")17:");
            r[42] = tail.find(")18:");
            r[43] = tail.find(")19:");
            r[44] = tail.find(")20:");
            r[45] = tail.find(")21:");
            r[46] = tail.find(")22:");
            r[47] = tail.find(")23:");
            k = 0;
            p = tail.length();
            for(int i = 0; i < ARRAY_SIZE; ++i) {
                if(r[i] != string::npos) {
                    p = r[i];
                    ++k;
                }

            }

            if(k == 1) {
                int beginning_of_time = p + 1;

// ID
                p = line.find(ID_COLON);
                if(p != string::npos) {
                    ++p;
                    id = line.substr(p);
                    int idLength = id.length();
                    if( idLength < SPACE_WIDTH ) {
                        id = padding(id);
                    }

                } else {
                    int u = line.find(BEFORE);
                    if(u != string::npos) {
                        id = ID_QUESTION;
                    } else {
                        return NON_DATE_LINE;
                    }

                }

                int m = slash_month_slash - 2;
                if(readyToRebuild || noSplitting) {
                    return m;
                }
// time
                tail = tail.substr(beginning_of_time);
                p = tail.find(GAP);
                if(p != string::npos) {
                    time = tail.substr(0, p); // 07:13:18
                } else {
                    time = tail;
                }

                int timeLength = time.length();
                if( timeLength < SPACE_WIDTH ) {
                    time = padding(time);
                }

// date
                int w = m + DATE_SIZE; 
                const string HEAD("20");
                tail = line.substr(m, DATE_SIZE); // 11/06/06
                date = HEAD + tail;
                string YEAR_SLASH = date.substr(0, YEAR_SLASH_SIZE);

                c = line.substr(w, 1);
                const string PARENTHESIS("(");
                const string CLOSE_BRACKET(")");
                if(c == PARENTHESIS) {
                    int e = w + 1;
                    c = line.substr(e, KANJI_SIZE);
                    p = YOBI.find(c);
                    if(p != string::npos) {
                        stringstream os;
                        os << PARENTHESIS << weekdays[ p/KANJI_SIZE ] << CLOSE_BRACKET;
                        day = os.str();
                    } else {
                        tail = line.substr(w);
                        int l = tail.find(CLOSE_BRACKET);
                        ++l;
                        day = line.substr(w, l); // (Fri) for example
                    }

                }

// res number
                head = line.substr(0, g);
                tail = MARKED_SPACE.substr(g);
                marked_res_no = head + tail;

                p = marked_res_no.find(GAP);
                res_no = marked_res_no.substr(0, p);

                tail = head;
                int z = COMMON_SPACE_SIZE - g;
                head = COMMON_SPACE.substr(0, z);
                common_res_no = head + tail;

// Removing YEAR_SLASH from name
                p = name.rfind(YEAR_SLASH);
                if(p != string::npos) {
                    name = name.substr(0, p);
                }

// Removing TOKOBI from name
                p = name.rfind(TOKOBI);
                if(p != string::npos) {
                    name = name.substr(0, p);
                }

                readyToRebuild = true;
                return m;
            }

        }

    }

    return NON_DATE_LINE;
}

std::string Characterizable::padding(std::string & s) {
    using namespace std;

    stringstream os;
    os << s << WIDE_SPACE;
    s = os.str();
    return s.substr(0, SPACE_WIDTH);
}

std::string Characterizable::pileOfErrorMessages() {
    if( error.length() == 0 ) {
        error = no_error;
    }

    return error;
}

std::string Characterizable::plus(std::string & again) {
    error += PUNCTUATION;
    error += again;
    return error;
}

std::string DateFollowed::anchor_res_no() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        os << NEW_LINE << ANCHOR << res_no << SPACE;
        line = os.str();
    }

    return line;
}

std::string DateFollowed::common() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        os << COMMA << date << day << GAP << time << COMMA << id << COMMA << common_res_no << COMMA <<  trimmed(name)  << COMMA;
        line = os.str();
    }

    return line;
}

std::string DateFollowed::interposed() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        os << res_no;

// Every name is interposed between colons.
        os << GAP << BEFORE << name << GAP << BEFORE;

        os << date << day << GAP << time << GAP << id;
        line = os.str();
    }

    return line;
}

std::string DateFollowed::name_id() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        os << SPACE << name << GAP << id;
        line = os.str();
    }

    return line;
}

std::string DateFollowed::rebuild() {
    using namespace std;

    if(readyToRebuild) {
        stringstream os;
        os << marked_res_no << date << day << GAP << time << GAP << id << GAP << name;
        line = os.str();
    }

    return line;
}

std::string DateFollowed::trimmed(std::string & name) {
    using namespace std;

    int nameLength = name.length();
    string c;
    string s(name);

    for(int i = nameLength - 1 ; i >= 0; --i) {
        c = s.substr(i, 1);
        if(GAP == c) {
            continue;
        } else {
            s = s.substr(0, i + 1 );
            break;
        }

    }

    return s;
}
