#ifndef DRAFO_H
#define DRAFO_H

#define KANA_KUTEN 0xA1
#define TO_BUFFER_SIZE 384
#include <map>
#include <vector>
#include "Characte.h"
#include "TimeName.h"

typedef std::map<std::string, int> ZENKAKU_HANKAKU;
typedef std::vector<std::string> ITEM;

class Drafo {
    bool firstLine, serialNumber, whoText;
    const bool NO_SPLITTING;
    const int NEW_LINE_LENGTH;
    ITEM draft, formal;
    const std::string ALL_QP, BELL, CLOSE_BRACKET, DRAFO_CSV, EMPTY, GAP, NEW_LINE;
    std::string ANCHOR, error, drafoCsv, saveName, whose;
    std::stringstream *buffer;
    std::stringstream *combos;
    ZENKAKU_HANKAKU z;

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    void listing() {
        std::string c = combos->str();
        *buffer << whose << NEW_LINE << c;
    }

    bool openSaveClose(std::string & fileName);
    bool readingCsvToProduceArrays();
    bool searchingItem(std::string & s);
    std::string checkOneByOne(std::string & line);
    std::string replaceDraftWithFormal(std::string & line);

public:
    ~Drafo() {
        delete buffer;
        delete combos;
    }

    std::string altered() const {
        return saveName;
    }

    std::string inquiry() const {
        return error;
    }

    bool altering(std::string & fileName);
    Drafo::Drafo(std::string & l, bool f, bool s, bool w);
};

void createDrafoCsv();
void createErrorText(std::string & messages);
void createExcludeText();

#endif // DRAFO_H
