#include "EditCount.h"

extern GIZE_CODE *gc; // gizePage.h and gize.cpp

bool EditCount::editCount() {
    bool result;
    GizeMask *gm = NULL;
    Drafo *dr = NULL;
    ExcludeText *et = NULL;
    TableCsv *tc = NULL;
    Triplet *tr = NULL;

    if(preedit) {
        et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
        if( et->altering(fileName) ) {
            fileName = et->altered();
        } else {
            error = et->inquiry();
            delete et;
            return false;
        }

        std::string drafoCsv = DRAFO_CSV;
        dr = new Drafo(drafoCsv, firstLine, serialNumber, whoText);
        if( dr->altering(fileName) ) {
            fileName = dr->altered();
        } else {
            error = dr->inquiry();
            delete dr; delete et;
            return false;
        }

        if(ticketForm) {
            tr = new Triplet(firstLine, serialNumber, whoText);
            if( tr->altering(fileName) ) {
                fileName = tr->altered();
            } else {
                error = tr->inquiry();
                delete dr; delete et; delete tr;
                return false;
            }

        }

        delete dr; delete et; delete tr;
    }

    if(quit) {
        textName = fileName;
        return true;
    }

    if(csv) {
        tc = new TableCsv(cell_5, serialNumber, whoText);
        if( tc->run(fileName) ) {
            textName = tc->saved();
            result = true;
        } else {
            error = tc->inquiry();
            result = false;
        }

        delete tc;
    } else {
        gm = new GizeMask(lines, cell_5, noSplitting, serialNumber, whoText);
        if( gm->run(fileName) ) {
            textName = gm->saved();
            result = true;
        } else {
            error = gm->inquiry();
            result = false;
        }

    }

    delete gm;
    return result;
}

bool EditCount::preediting() {
    Drafo *dr = NULL;
    ExcludeText *et = NULL;
    Triplet *tr = NULL;

    et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
    if( et->altering(fileName) ) {
        fileName = et->altered();
    } else {
        error = et->inquiry();
        delete et;
        return false;
    }

    std::string drafoCsv = DRAFO_CSV;
    dr = new Drafo(drafoCsv, firstLine, serialNumber, whoText);
    if( dr->altering(fileName) ) {
        fileName = dr->altered();
    } else {
        error = dr->inquiry();
        delete dr; delete et;
        return false;
    }

    if(ticketForm) {
        tr = new Triplet(firstLine, serialNumber, whoText);
        if( tr->altering(fileName) ) {
            fileName = tr->altered();
        } else {
            error = tr->inquiry();
            delete dr; delete et; delete tr;
            return false;
        }

	}

    delete dr; delete et; delete tr;
    textName = fileName;
    return true;
}

bool EditCount::readManageText() {
    using namespace std;

    char c[BUFFER_SIZE];
    string *p = new string("");
    ifstream in( FULL_PATH_NAME.c_str() );
    if( in.fail() ) {
        error = "e19: ifstream in( " + FULL_PATH_NAME + CLOSE_BRACKET;
        return false;
    }

    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    stringArrayToValues();
    delete p;
    return true;
}

bool EditCount::setting(std::string & f, std::string & fi, std::string & l, int li, bool c, bool cs, bool fir, bool n, bool p, bool q, bool s, bool t, bool w) {
    using namespace std;

    FULL_PATH_NAME = f;
    readManageText();

    fileName = fi;
    list_of_items = l;
    lines = li;
    cell_5 = c;
    csv = cs;
    firstLine = fir;
    noSplitting = n;
    preedit = p;
    quit = q;
    serialNumber = s;
    ticketForm = t;
    whoText = w;

    testDrafoCsv();

    if(lines < 1 || 8 < lines) {
        lines = LINES;
    }

    ifstream test( list_of_items.c_str() );
    if( test.fail() ) {
        error = "e20: ifstream test( " + list_of_items + CLOSE_BRACKET;

        if(EXCLUDE_TEXT == list_of_items) {
            createExcludeText();
        }

        list_of_items = EXCLUDE_TEXT;
        return false;
    } else {
        test.close();
    }

    return true;
}

bool EditCount::testDrafoCsv() {
    using namespace std;

    bool result = true;
    ifstream test( DRAFO_CSV.c_str() );
    if( test.fail() ) {
        createDrafoCsv();
        result = false;
    } else {
        test.close();
    } 

    return result;
}

EditCount::EditCount(): DRAFO_CSV("drafo.csv"), EXCLUDE_TEXT("exclude.txt"), LINES(2), m0(""), m1("who.txt"), m2("exclude.txt"), m3("2"), m4("0"), m5("1"), m6("0"), m7("1"), m8("5000"), m9("1"), m10("0"), m11("0"), m12("1"), ZERO("0") {
    csv = false;
    quit = false;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; 
}

void createDrafoCsv() {
    using namespace std;

    const string DRAFO_CSV("drafo.csv");
    ofstream file( DRAFO_CSV.c_str() );
    file << "&#160;, ," << endl;
    file << "&nbsp;, ," << endl;
    file << "a,A," << endl;
    file << "l,L," << endl;
    file << "p,P," << endl;
    file << "q,Q," << endl;
    file << "\\,, ," << endl;
    file << "., ," << endl;
    file << "      , ," << endl;
    file << "     , ," << endl;
    file << "    , ," << endl;
    file << "   , ," << endl;
    file << "  , ," << endl;
    file << " 1 , 01 ," << endl;
    file << " 2 , 02 ," << endl;
    file << " 3 , 03 ," << endl;
    file << " 4 , 04 ," << endl;
    file << " 5 , 05 ," << endl;
    file << " 6 , 06 ," << endl;
    file << " 7 , 07 ," << endl;
    file << " 8 , 08 ," << endl;
    file << " 9 , 09 ," << endl;
    file << "ALLQP,ALL QP," << endl;
    file << "|,/," << endl;
}

void createExcludeText() {
    using namespace std;

    const string EXCLUDE_TEXT("exclude.txt");
    ofstream file( EXCLUDE_TEXT.c_str() );
    file << "ʂ" << endl; // Shift_JIS
    file << " ID:" << endl;
}

void EditCount::stringArrayToValues() {
    using namespace std;

    fileName = m[1];
    list_of_items = m[2];
    lines = stringToInteger(m[3]);

    cell_5 = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = stringToInteger(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    ticketForm = (ZERO == m[10]) ? false : true;
    whoText = (ZERO == m[11]) ? false : true;
    toGize = (ZERO == m[12]) ? false : true;

    gc->cell_5 = cell_5;
    gc->csv = csv;
    gc->fileName = fileName;
    gc->firstLine = firstLine;
    gc->FULL_PATH_NAME = FULL_PATH_NAME;
    gc->lines = lines;
    gc->list_of_items = list_of_items;
    gc->noSplitting = noSplitting;
    gc->preedit = preedit;
    gc->rowCount = rowCount;
    gc->serialNumber = serialNumber;
    gc->textName = textName;
    gc->ticketForm = ticketForm;
    gc->whoText = whoText;
}
