#include "Exclude.h"

bool ExcludeText::altering(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e21: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string clearing(EMPTY);
    if( in.getline(c, BUFFER_SIZE) ) {
// Line-1
        string line(c);
        if(firstLine) {
            add(line);
            listing();
            clear(clearing);
        }

    } else {
        const string LINE_1_ERROR("e22(Line-1): in.getline(c, BUFFER_SIZE) ");
        error = LINE_1_ERROR;
        return false;
    }

    bool through = false;
    string *p = new string("");
    Characterizable *lineType = new DateFollowed(*p, NO_SPLITTING);
    int r;
    string s;

    readingToProduceArray();
    if(whoText) {
        const string who_text(WHO_TEXT);
        saveName = who_text;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        saveName = wt.temporaryName(serialNumber);
    }

    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        s = *p;

        delete lineType;
        lineType = new DateFollowed(s, NO_SPLITTING);
        r = lineType->dateLine();
        if(r > 0) {
            listing();
            clear(s);
            continue;
        }

        through = searchingItem(s);
        if(through) {
            while( in.getline(c, BUFFER_SIZE) ) {
                delete p;
                p = new string(c);
                s = *p;

                delete lineType;
                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType->dateLine();
                if(r > 0) {
                    break;
                }

            }

            if( in.eof() || in.fail() ) { // at EOF 
                clear(clearing);
                break;
            } else { // before EOF 
                clear(s);
                continue;
            }

        } else {
            add(s);
        }

    }

    in.close();
    listing();
    openSaveClose(saveName);

    delete lineType;
    delete p;
    return true;
}

bool ExcludeText::openSaveClose(std::string & fileName) {
    using namespace std;

// Trimming
    string s = buffer->str();
    int size = s.length();
    string c;
    for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
        c = s.substr(i, NEW_LINE_LENGTH);
        if(NEW_LINE == c) {
            continue;
        } else {
            s = s.substr(i);
            break;
        }

    }

// Writing
    ofstream saveFile( fileName.c_str() );
    if( saveFile.fail() ) {
        error = "e23: ofstream saveFile( " + fileName + CLOSE_BRACKET;
        return false;
    }

    saveFile << s;
    saveFile.close();
    return true;
}

bool ExcludeText::readingToProduceArray() {
    using namespace std;

// Reading list_of_items to produce an array
    ifstream in( list_of_items.c_str() );
    if( in.fail() ) {
        error = "e24: ifstream in( " + list_of_items + CLOSE_BRACKET;
        return false;
    }

    char c[BUFFER_SIZE];
    string *p = new string("");
    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);

        if( p->length() > 0 ) {
            item.push_back(*p);
        } else {
            item.push_back(BELL);
        }

    }

    in.close();
    delete p;
    return true;
}

bool ExcludeText::searchingItem(std::string & s) {
    using namespace std;

    bool found = false;
    int q;

    for(ITEM::iterator i = item.begin(); i != item.end(); ++i) {
        q = s.find(*i);
        if(q != string::npos) {
            found = true;
            break;
        }

    }

    return found;
}

ExcludeText::ExcludeText(std::string & l, bool f, bool s, bool w): BELL("\\a"), CLOSE_BRACKET(" )"), EMPTY(""), EXCLUDE_TEXT("exclude.txt"), NEW_LINE("\n"), NEW_LINE_LENGTH(1), NO_SPLITTING(true) {
    using namespace std;

    firstLine = f;
    list_of_items = l;
    serialNumber = s;
    whoText = w;
    ifstream test( EXCLUDE_TEXT.c_str() );
    if( test.fail() ) {
        createExcludeText();
    } else {
        test.close();
    }

    buffer = new stringstream();
    combos = new stringstream();
    whose = EMPTY;
}
