#ifndef TABLE_CSV_H
#define TABLE_CSV_H

#define A123 7
#define A789 448
#define A147 73
#define A369 292
#define A46  40
#define A28  130
#define A19  257
#define A37  68
#define B00000000000000000000000000000000 0
#define B00000000000000000000000000000001 1
#define B00000000000000000000000000000010 2
#define B00000000000000000000000000000100 4
#define B00000000000000000000000000001000 8
#define B00000000000000000000000000010000 16
#define B00000000000000000000000000100000 32
#define B00000000000000000000000001000000 64
#define B00000000000000000000000010000000 128
#define B00000000000000000000000100000000 256
#define B000000111 0x07   /*  7                       */
#define B111000000 0x1C0  /*  448 = 256 + 12 * 16     */
#define B001001001 0x49   /*  73 = 4 * 16 + 9         */
#define B100100100 0x124  /*  292 = 256 + 2 * 16 + 4  */
#define B000101000 0x28   /*  40 = 16 * 2 + 8         */
#define B010000010 0x82   /*  130 = 8 * 16 + 2        */
#define B100000001 0x101  /*  257 = 256 + 1           */
#define B001000100 0x44   /*  68 = 4 * 16 + 4         */
#define CELL_COUNT 9
#define CSV_FILE ".csv"
#define DRAW_ARRAY_SIZE 12
#define MASK_COUNT 8
#define STANDARD_LINE_LENGTH 23 // "03 06 14/20 24/28 32 37"
#include <queue>
#include "Characte.h"
#include "gizePage.h"

class TableCsv {
    bool cell_5, scope, serialNumber, whoText;
    bool unbroken[MASK_COUNT];
    const bool SORT_IN_REVERSE_ORDER;
    const int ALL_QP_SIZE, LINES, SEPARATOR_SIZE;
    const std::string ALL_QP, CLOSE_BRACKET, COMMA, COMMA_GAP, EMPTY, FREE, GAP, GAP_SLASH, GAP_SLASH_SLASH, ID_COLON, NEW_LINE, QP, SEPARATOR, SLASH, SLASH_SLASH, TILDE, TRACE_0, TRACE_1, TRACE_2, TRACE_3, TRACE_4, TRACE_5, TRACE_6, TRACE_7;
    int count, NEW_LINE_LENGTH, split, total;
    int mask[MASK_COUNT];
    int shift[10];
    std::string error, fileName, textName, whose;
    std::string a[DRAW_ARRAY_SIZE];
    std::string draw[DRAW_ARRAY_SIZE];
    std::string trace[MASK_COUNT];
    std::stringstream *buffer;
    std::stringstream *combos;

    bool allQP(char *p) {
        using namespace std;

        string s(p);
        if(scope) {
            return true;
        }

        int q = s.find(ALL_QP);
        if(q != string::npos) {
            scope = true;
        }

        return scope;
    }

    bool allQP(std::string & s) {
        using namespace std;

        if(scope) {
            return true;
        }

        int q = s.find(ALL_QP);
        if(q != string::npos) {
            scope = true;
        }

        return scope;
    }

    void add(int lines, std::string & s) {
        *combos << lines << COMMA << s << SEPARATOR;
        count += 1;
    }

    void clear(std::string & s, int r) {
        delete combos;
        combos = new std::stringstream();
        count = 0;
        scope = false;

        whose = s;
        split = r;
    }

    bool openSaveClose(std::string & fileName);
    bool sorting(std::string & fileName);
    int and_mask_equals_mask(int a);
    std::string assembling();
    void dividing(char *p, char *to, int to_array_size);
    void listing();

public:
    ~TableCsv() {
        delete buffer;
        delete combos;
    }

    std::string inquiry() const {
        return error;
    }

    std::string saved() const {
        return textName;
    }

    bool run(std::string & fileName);
    bool setting(std::string & f, int l, bool c, bool n, bool s, bool w);
    TableCsv(bool c, bool s, bool w);
};

#endif // TABLE_CSV_H
