#include "TimeName.h"

namespace {
    int sn;
}

std::string TimeName::temporaryName(bool serial_number) {
    using namespace std;

    int m, sec;
    struct tm *time_block;
    time_t timer;
    timer = time(NULL);
    time_block = localtime(&timer);
    m = time_block->tm_min;
    sec = time_block->tm_sec;

    if(serial_number) {
        setSerialNumber();
    }

    stringstream os;
    os << name << m << HYPHEN << sec << extension;
    string ti = os.str();
    if(ti == timeName) {
        setSerialNumber();

        stringstream om;
        om << name << m << HYPHEN << sec << extension;
        ti = om.str();
    }

    timeName = ti;
    return timeName;
}

void TimeName::readSerialNumber() {
    using namespace std;

    char buffer[BUFFER_SIZE];
    ifstream buffered(SERIAL_TEXT);
    if( buffered.getline(buffer, BUFFER_SIZE) ) {
        string line(buffer);
        stringstream os(line);
        os >> sn;
    } else {
        zeroSerialNumber();
    }
}

void TimeName::setSerialNumber() {
    using namespace std;

    ++sn;
    ofstream file(SERIAL_TEXT);
    file << sn << endl;

    stringstream os;
    os << base << sn << HYPHEN;
    const string na = os.str();
    name = na;
}

void TimeName::zeroSerialNumber() {
    using namespace std;

    sn = 0;
    ofstream file(SERIAL_TEXT);
    file << sn << endl;
}

