#include "Triplet.h"

bool Triplet::altering(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e16: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[TO_BUFFER_SIZE];
    char to[TO_BUFFER_SIZE];
    string clearing(EMPTY);
    if( in.getline(c, BUFFER_SIZE) ) {
        string line(c);
        if(firstLine) {
            add(line);
            listing();
            clear(clearing);
        }

        int gap_slash_length = checkLine1(line);
        switch(gap_slash_length) {
        case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
            error = "e11: ADD THE DRAW TO LINE-1 OF WHO.TXT";
            return false;
        case TOO_FEW_GAPS:
            error = "e10: TOO FEW GAPS";
            return false;
        case TOO_FEW_SLASHES:
            error = "e6: TOO FEW SLASHES";
            return false;
        case TOO_SHORT_LINE:
            error = "e5: TOO SHORT LINE";
            return false;
        default:
            break;
        }

    }

    bool doubled = false;
    int k, line_length, n, r, row;
    int line = 0;
    string *p = new string("");
    string s;
    stringstream *os = new stringstream();
    Characterizable *lineType = new DateFollowed(*p, NO_SPLITTING);

    if(whoText) {
        const string who_text(WHO_TEXT);
        bingo5List = who_text;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        bingo5List = wt.temporaryName(serialNumber);
    }

    while( in.getline(c, BUFFER_SIZE) ) {
        delete p;
        p = new string(c);
        s = *p;
        delete lineType;
        lineType = new DateFollowed(s, NO_SPLITTING);
        r = lineType->dateLine();
        if(r > 0) {
            listing();
            clear(s);
            line = 0;
            continue;
        }

        scope = allQP(s);

// Trimming so that the line can begin with numbers.
        line_length = strlen(c);
        n = strcspn(c, "0123456789");
        if(n > 0) {
            line_length -= n;
            memmove(c, &c[n], line_length);
            c[line_length] = '\0';
        }

        if( line_length < MINIMUM_LINE_LENGTH ) {
            if( line_length < HALF_LENGTH ) {
                continue;
            } else {
// Doubling 
                strcpy(to, c);
                strcat(c, NON_NUMBER);
                strcat(c, to);
                doubled = true;
            } // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH

        }

        line += 1;
        dividing(c, to, TO_BUFFER_SIZE);
        k = line%TRIPLET; // k = 1, 2, 0
        switch(k) {
        case 1:
            if( inappropriate_cell_1() ) {
                line = 0;
                continue;
            }

            break;
        case 2:
            if( inappropriate_cell_4() ) {
                line = 0;
                continue;
            }

            break;
        default:
            if( inappropriate_cell_7() ) {
                line = 0;
                continue;
            }

            break;
        }

        for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) { // i = 1, 2, 3, 4, 5, 6
            triplet[k][i] = a[i];
        }

        if(k == 0) {
// Unifying three lines into a line that includes four slashes.
            delete os;
            os = new stringstream();
            *os << triplet[1][1] << GAP << triplet[1][2] << GAP << triplet[1][3] << GAP_SLASH;
            *os << triplet[2][1] << GAP << triplet[2][2] << GAP_SLASH;
            *os << triplet[0][1] << GAP << triplet[0][2] << GAP << triplet[0][3] << GAP_SLASH_SLASH << NEW_LINE;

            if(doubled) {
                doubled = false;
            } else {
                *os << triplet[1][4] << GAP << triplet[1][5] << GAP << triplet[1][6] << GAP_SLASH;
                *os << triplet[2][3] << GAP << triplet[2][4] << GAP_SLASH;
                *os << triplet[0][4] << GAP << triplet[0][5] << GAP << triplet[0][6] << GAP_SLASH_SLASH << NEW_LINE;
            }

            s = os->str();
            add(s);
            line = 0;
        }

    } 

    in.close();
    listing();
    openSaveClose(bingo5List);

    delete lineType;
    delete os;
    delete p;
    return true;
}

bool Triplet::detecting(std::string & fileName) {
    using namespace std;

    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e2: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[TO_BUFFER_SIZE];
    char to[TO_BUFFER_SIZE];
    string clearing(EMPTY);
    if( in.getline(c, BUFFER_SIZE) ) {
        ;// Line-1
    } else {
        const string LINE_1_ERROR("e33(Line-1): in.getline(c, BUFFER_SIZE) ");
        error = LINE_1_ERROR;
        return false;
    }

    bool undetected = true;
    bool doubled = false;
    int gap_slash_length, k, line_length, n, r;
    int line = 0;
    string *p = new string("");
    string s;
    stringstream *os = new stringstream();
    Characterizable *lineType = new DateFollowed(*p, NO_SPLITTING);

    if(whoText) {
        const string who_text(WHO_TEXT);
        bingo5List = who_text;
    } else {
        TimeName wt(WHO, TEXT_FILE);
        bingo5List = wt.temporaryName(serialNumber);
    }

    while(undetected) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            s = *p;
            delete lineType;
            lineType = new DateFollowed(s, NO_SPLITTING);
            r = lineType->dateLine();
            if(r > 0) {
                listing();
                clear(s);
                line = 0;
                continue;
            }

            scope = allQP(s);

// Trimming so that the line can begin with numbers.
            line_length = strlen(c);
            n = strcspn(c, "0123456789");
            if(n > 0) {
                line_length -= n;
                memmove(c, &c[n], line_length);
                c[line_length] = '\0';
            }

            if( line_length < MINIMUM_LINE_LENGTH ) {
                if( line_length < HALF_LENGTH ) {
                    continue;
                } else {
// Doubling 
                    strcpy(to, c);
                    strcat(c, NON_NUMBER);
                    strcat(c, to);
                    doubled = true;
                } // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH

            }

            line += 1;
            dividing(c, to, TO_BUFFER_SIZE);
            k = line%TRIPLET; // k = 1, 2, 0
            switch(k) {
            case 1:
                if( inappropriate_cell_1() ) {
                    line = 0;
                    continue;
                }

                break;
            case 2:
                if( inappropriate_cell_4() ) {
                    line = 0;
                    continue;
                }

                break;
            default:
                if( inappropriate_cell_7() ) {
                    line = 0;
                    continue;
                }

                break;
            }

            for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) { // i = 1, 2, 3, 4, 5, 6
                triplet[k][i] = a[i];
            }

            if(k == 0) {
// Unifying three lines into a line that includes four slashes.
                delete os;
                os = new stringstream();
                *os << triplet[1][1] << GAP << triplet[1][2] << GAP << triplet[1][3] << GAP_SLASH;
                *os << triplet[2][1] << GAP << triplet[2][2] << GAP_SLASH;
                *os << triplet[0][1] << GAP << triplet[0][2] << GAP << triplet[0][3] << GAP_SLASH_SLASH << NEW_LINE;

                if(doubled) {
                    doubled = false;
                }

                s = os->str();
                line = 0;
                gap_slash_length = checkLine1(s);
                switch(gap_slash_length) {
                case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
                    continue;
                case TOO_FEW_GAPS:
                    continue;
                case TOO_FEW_SLASHES:
                    continue;
                case TOO_SHORT_LINE:
                    continue;
                default:
                    undetected = false;
                    break;
                }

            } // if(k == 0)

        } else {
            break; // in.getline(c, BUFFER_SIZE)
        }

    } // while

    in.close();
    delete lineType; delete os; delete p;

    if(undetected) {
        return false;
    } else {
        return true; // At least one matrix has been detected.
    }

}

bool Triplet::inappropriate_cell_1() {
    bool appropriate = false;

    if(a1 == a[1]) {
        appropriate = true;
    } else if(a2 == a[1]) {
        appropriate = true;
    } else if(a3 == a[1]) {
        appropriate = true;
    } else if(a4 == a[1]) {
        appropriate = true;
    } else if(a5 == a[1]) {
        appropriate = true;
    }

    return !appropriate;
}

bool Triplet::inappropriate_cell_4() {
    bool appropriate = false;

    if(a16 == a[1]) {
        appropriate = true;
    } else if(a17 == a[1]) {
        appropriate = true;
    } else if(a18 == a[1]) {
        appropriate = true;
    } else if(a19 == a[1]) {
        appropriate = true;
    } else if(a20 == a[1]) {
        appropriate = true;
    }

    return !appropriate;
}

bool Triplet::inappropriate_cell_7() {
    bool appropriate = false;

    if(a26 == a[1]) {
        appropriate = true;
    } else if(a27 == a[1]) {
        appropriate = true;
    } else if(a28 == a[1]) {
        appropriate = true;
    } else if(a29 == a[1]) {
        appropriate = true;
    } else if(a30 == a[1]) {
        appropriate = true;
    }

    return !appropriate;
}

bool Triplet::openSaveClose(std::string & fileName) {
    using namespace std;

// Trimming
    string s = buffer->str();
    int size = s.length();
    string c;
    for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
        c = s.substr(i, NEW_LINE_LENGTH);
        if(NEW_LINE == c) {
            continue;
        } else {
            s = s.substr(i);
            break;
        }

    }

// Writing
    ofstream saveFile( fileName.c_str() );
    if( saveFile.fail() ) {
        error = "e1: ofstream saveFile( " + fileName + CLOSE_BRACKET;
        return false;
    }

    saveFile << s;
    saveFile.close();
    return true;
}

Triplet::Triplet(bool f, bool s, bool w): a1("01"), a2("02"), a3("03"), a4("04"), a5("05"), a16("16"), a17("17"), a18("18"), a19("19"), a20("20"), a26("26"), a27("27"), a28("28"), a29("29"), a30("30"), ALL_QP("ALL QP"), CLOSE_BRACKET(" )"), EMPTY(""), GAP(" "), GAP_ALL_QP(" ALL QP"), GAP_SLASH(" /"), GAP_SLASH_SLASH(" //"), MINUS("-"), NEW_LINE("\n"), NEW_LINE_LENGTH(1), NO_SPLITTING(true), SLASH("/") {
    using namespace std;

    firstLine = f;
    serialNumber = s;
    scope = false;
    whoText = w;

    buffer = new stringstream();
    combos = new stringstream();
    whose = EMPTY;
}

int Triplet::checkLine1(std::string & line) {
    using namespace std;
/*
01234567890123456789012345678901234567
04 09 12 /16 22 /26 32 38 // -123
04 09 12 /16 22 /26 32 38 //
04 09 12/16 22/26 32 38 -123
04 09 12/16 22/26 32 38
*/
    int q;
    string s = line;
    for(int i = 0; i < 5; ++i) {
        q = s.find(GAP);
        if(q != string::npos) {
            q += GAP_SIZE;
            s = s.substr(q);
        } else {
            return TOO_FEW_GAPS;
        }

    }

    int lineLength = line.length();
    if(lineLength < STANDARD_LINE_LENGTH) {
        return TOO_SHORT_LINE;
    }

    s = line;
    for(int i = 0; i < 2; ++i) {
        q = s.find(SLASH);
        if(q != string::npos) {
            q += SLASH_SIZE;
            s = s.substr(q);
        } else {
            return TOO_FEW_SLASHES;
        }

    }

    s = line;
    string c9 = s.substr(9, 1);
    string c16 = s.substr(16, 1);
    string c26 = s.substr(26, 1);
    string c27 = s.substr(27, 1);
    if(c9 == SLASH && c16 == SLASH) {
        if(c26 == SLASH && c27 == SLASH) {
            return BINGO5;
        }

    }

    string c28 = s.substr(28, 1);
    string c29 = s.substr(29, 1);
    if(c28 == SLASH && c29 == MINUS) {
        return BINGO5;
    }

    string c8 = s.substr(8, 1);
    string c14 = s.substr(14, 1);
    if(c8 == SLASH && c14 == SLASH) {
        return BINGO5;
    }

    string c23 = s.substr(23, 1);
    string c24 = s.substr(24, 1);
    if(c23 == SLASH && c24 == MINUS) {
        return BINGO5;
    }

    return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
}

void Triplet::dividing(char *p, char *to, int to_array_size) {
    using namespace std;

    char *from;
    int n, u;
    string *to_string = new string("");

    a[0] = EMPTY;
    memset(to, 0, to_array_size);
    for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) {
        n = strspn(p, "0123456789");
        from = p;
        p += n;

        u = strcspn(p, "0123456789");
        p += u;

        memcpy(to, from, n);
        to[n] = '\0';
        delete to_string;
        to_string = new string(to);
        a[i] = *to_string;
    }

    delete to_string;
}

void Triplet::listing() {
    std::string c = combos->str();
    *buffer << whose << NEW_LINE;

    if(scope) {
        int q = c.length();
        q -= NEW_LINE_LENGTH;
        c = c.substr(0, q);
        *buffer << c << GAP_ALL_QP << NEW_LINE;
    } else {
        *buffer << c;
    }

}
