#ifndef TRIPLET_H
#define TRIPLET_H

#define HALF_LENGTH 8 // "05 06 13"
#define MINIMUM_LINE_LENGTH 17 // "05 06 13/01 07 14"
#define NON_NUMBER " | "
#define NON_NUMBER_LENGTH 2 // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH
#define SLASH_SIZE 1
#define TRIPLET 3
#define TRIPLET_ARRAY_SIZE 7
#include "TableCsv.h"

class Triplet {
    bool firstLine, serialNumber, scope, whoText;
    const bool NO_SPLITTING;
    const int NEW_LINE_LENGTH;
    const std::string a1, a2, a3, a4, a5, a16, a17, a18, a19, a20, a26, a27, a28, a29, a30, ALL_QP, CLOSE_BRACKET, EMPTY, GAP, GAP_ALL_QP, GAP_SLASH, GAP_SLASH_SLASH, MINUS, NEW_LINE, SLASH;
    std::string error, bingo5List, whose;
    std::string a[DRAW_ARRAY_SIZE];
    std::string triplet[TRIPLET][TRIPLET_ARRAY_SIZE];
    std::stringstream *buffer;
    std::stringstream *combos;

    bool allQP(std::string & s) {
        using namespace std;

        if(scope) {
            return true;
        }

        int q = s.find(ALL_QP);
        if(q != string::npos) {
            scope = true;
        }

        return scope;
    }

    void add(std::string & s) {
        *combos << s << NEW_LINE;
    }

    void clear(std::string & s) {
        delete combos;
        combos = new std::stringstream();
        scope = false;

        whose = s;
    }

    void clear(const std::string & s) {
        std::string clearing(s);
        delete combos;
        combos = new std::stringstream();
        whose = s;
    }

    bool inappropriate_cell_1();
    bool inappropriate_cell_4();
    bool inappropriate_cell_7();
    bool openSaveClose(std::string & fileName);
    int checkLine1(std::string & line);
    void dividing(char *p, char *to, int to_array_size);
    void listing();

public:
    ~Triplet() {
        delete buffer;
        delete combos;
    }

    std::string altered() const {
        return bingo5List;
    }

    std::string inquiry() const {
        return error;
    }

    bool altering(std::string & fileName);
    bool detecting(std::string & fileName);
    Triplet(bool f, bool s, bool w);
};

#endif // TRIPLET_H
