/*
gize Version 1.14
Finding Bingo-5 winners
Copyright 2017 Sogaya

gcc (GCC) 3.4.2 (mingw-special)

*/

#include "EditCount.h"

namespace {
    const int ERROR_CODE = 1;
    const int LINES = 2;
    const int NEW_LINE_LENGTH = 1;
    const std::string CLOSE_BRACKET(" )");
    const std::string DRAFO_CSV("drafo.csv");
    const std::string EXCLUDE_TEXT("exclude.txt");
    const std::string EMPTY("");
    const std::string GAP(" ");
    const std::string ZERO("0");
    const std::string NEW_LINE("\n");
    const std::string TO_TEXT("to.txt"); // backup file of WHO_TEXT

    const std::string m0(           ""); // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
    const std::string m1(    "who.txt"); // m[1], fileName
    const std::string m2("exclude.txt"); // m[2], list_of_items
    const std::string m3(          "2"); // m[3], lines
    const std::string m4(          "0"); // m[4], cell_5
    const std::string m5(          "1"); // m[5], firstLine
    const std::string m6(          "0"); // m[6], noSplitting
    const std::string m7(          "1"); // m[7], preedit
    const std::string m8(       "5000"); // m[8], rowCount
    const std::string m9(          "1"); // m[9], serialNumber
    const std::string m10(         "0"); // m[10], ticketForm
    const std::string m11(         "0"); // m[11], whoText
    const std::string m12(         "1"); // m[12], toGize

    bool cell_5, csv, firstLine, noSplitting, preedit, serialNumber, ticketForm, whoText;
    int lines, rowCount;
    std::string error, fileName, FULL_PATH_NAME, list_of_items, textName;
    std::string m[ MANAGE_TEXT_LINE_COUNT + 1 ];
}

GIZE_CODE gize_code;
GIZE_CODE *gc = &gize_code;

bool backupToProduceToText() {
    using namespace std;

    ifstream in(WHO_TEXT);
    if( in.fail() ) {
        const string who_text(WHO_TEXT);
        error = "e25: ifstream in( " + who_text + CLOSE_BRACKET;
        return false;
    }

    char c[FILE_NAME_SIZE];
    stringstream os;
    while( in.getline(c, FILE_NAME_SIZE) ) {
        os << c << NEW_LINE;
    }

    string s = os.str();
    ofstream to_text( TO_TEXT.c_str() );
    to_text << s << endl;
    return true;
}

bool detectingMatrix(const std::string & d, std::string & l, bool f, bool s, bool w) {
    std::string drafo_csv = d;
    std::string list_of_items = l;
    bool firstLine = f;
    bool serialNumber = s;
    bool whoText = w;

    Triplet *md = new Triplet(firstLine, serialNumber, whoText);
    bool matrix_detected = md->detecting(fileName);
    if(matrix_detected) {
        backupToProduceToText();

        ExcludeText *et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
        if( et->altering(fileName) ) {
            fileName = et->altered();
        } else {
            error = et->inquiry();
            return false;
        }

        Drafo *dr = new Drafo(drafo_csv, firstLine, serialNumber, whoText);
        if( dr->altering(fileName) ) {
            fileName = dr->altered();
        } else {
            error = dr->inquiry();
            return false;
        }

        Triplet *tr = new Triplet(firstLine, serialNumber, whoText);
        if( tr->altering(fileName) ) {
            fileName = tr->altered();
            readingToProduceWhoText(fileName);
        } else {
            error = tr->inquiry();
            return false;
        }

        delete dr; delete et; delete tr;
    }

    delete md;
    return true;
}

bool readFilesBeforehand(std::string & commandLine) {
    using namespace std;

    bool destroyWhoText = false;
    bool quit = false;
    bool remove_first = true;
    bool toGize = true;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const string COUNT("-c");
    const string CSV("--csv");
    const string EXCLUDE("-e");
    const string FREE("-f");
    const string INCLUDE_ONLY_TWO("-i");
    const string NO_EDITING("-e-");
    const string NO_OVERWRITING("-to-");
    const string NO_PREEDITING("-p-");
    const string NO_REMOVING("-r-");
    const string NO_SPLITTING("-s-");
    const string OVERWRITE("-o");
    const string QUIT("-q");
    const string REMOVE_LINE_1("-1-");
    const string TICKET("-t");
    const string TABLE("-a");
    const string version_comments("-VC");
    const string version_guide("-V");
    int q;
    Numbered *n = new Numbered("");
    string *p = new string("");
    string argument;
    string who_text("who.txt");
    string c_gize_manage_text("C:\\gize\\manage.txt");
    string manage_text_name(MANAGE_TEXT);
    string m[ MANAGE_TEXT_LINE_COUNT + 1 ];

    cell_5 = false;
    csv = false;
    gc->csv = false;
    fileName = who_text;
    firstLine = true;
    FULL_PATH_NAME = c_gize_manage_text;
    lines = LINES;
    list_of_items = EXCLUDE_TEXT;
    m[0] = m0; m[1] = m1; m[2] = m2; m[3] = m3; m[4] = m4; m[5] = m5; m[6] = m6; m[7] = m7; m[8] = m8; m[9] = m9; m[10] = m10; m[11] = m11; m[12] = m12; 
    noSplitting = false;
    preedit = true;
    rowCount = CSV_LINE_COUNT;
    serialNumber = true;
    ticketForm = false;
    whoText = true;

    gc->onlyTwo = false;

// C:\gize\manage.txt for example
    string firstPart = currentDirectory(); // OS-specific.h and OS-specific.cpp
    NAMES a = driveDirectoryBase(firstPart);
    string SEPARATOR = a.separator;
    string root = a.name[1];
    if (firstPart == root) { // C:\ for example
        FULL_PATH_NAME = root + manage_text_name;
    } else { // C:\gize for example
        FULL_PATH_NAME = firstPart + SEPARATOR + manage_text_name;
    }

    gc->FULL_PATH_NAME = FULL_PATH_NAME;

    ifstream file( FULL_PATH_NAME.c_str() );
    if ( file.fail() ) { // MANAGE_TEXT
// Creating MANAGE_TEXT
        ofstream manage_text( FULL_PATH_NAME.c_str() );
        for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
            manage_text << m[line] << endl;
        }

        return false;
    }

// Reading MANAGE_TEXT
    char c[BUFFER_SIZE];
    ifstream in( FULL_PATH_NAME.c_str() );
    m[0] = FULL_PATH_NAME;
    for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
        if( in.getline(c, BUFFER_SIZE) ) {
            delete p;
            p = new string(c);
            m[line] = *p;
        } else {
            break;
        }

    }

    in.close();
    fileName = m[1];
    list_of_items = m[2];
    lines = stringToInteger(m[3]);
    const int based_on_m3 = lines;

    cell_5 = (ZERO == m[4]) ? false : true;
    firstLine = (ZERO == m[5]) ? false : true;
    noSplitting = (ZERO == m[6]) ? false : true;
    preedit = (ZERO == m[7]) ? false : true;
    rowCount = stringToInteger(m[8]);
    serialNumber = (ZERO == m[9]) ? false : true;
    ticketForm = (ZERO == m[10]) ? false : true;
    destroyWhoText = (ZERO == m[11]) ? false : true;
    toGize = (ZERO == m[12]) ? false : true;

    char r[SMALL_BUFFER_SIZE];
    Dividing d(commandLine);
    const int FIELD_COUNT = d.fieldCount();
    for(int i = 1; i < FIELD_COUNT; ++i) {
        argument = d.a(i);
        if( argument.length() == 0 ) {
            break;
        }

        if(CSV == argument) {
            csv = true;
        } else if(EXCLUDE == argument) {
            list_of_items = EXCLUDE_TEXT;
        } else if(FREE == argument) {
            cell_5 = true;
        } else if(INCLUDE_ONLY_TWO == argument) {
            gc->onlyTwo = true;
        } else if(NO_EDITING == argument) {
            preedit = false;
        } else if(NO_OVERWRITING == argument) {
            toGize = false;
        } else if(NO_PREEDITING == argument) {
            preedit = false;
        } else if(NO_REMOVING == argument) {
            remove_first = false;
        } else if(NO_SPLITTING == argument) {
            noSplitting = true;
        } else if(OVERWRITE == argument) {
            destroyWhoText = true;
        } else if(QUIT == argument) {
            quit = true;
        } else if(REMOVE_LINE_1 == argument) {
            firstLine = false;
        } else if(TABLE == argument) {
            csv = true;
        } else if(TICKET == argument) {
            ticketForm = true;
        } else if(version_guide == argument) {
            guide(WITHOUT_COMMENTS);
            delete n; delete p;
            return false;
        } else if(version_comments == argument) {
            guide(WITH_COMMENTS);
            delete n; delete p;
            return false;
        } else {
            if(whoText) {
                fileName = argument;
                whoText = false;
            } else {
                q = argument.find(COUNT);
                if(q != string::npos) {
                    delete n;
                    strcpy(r, argument.c_str() );
                    n = new Numbered(r);
                    lines = n->number();
                    if( n->parameter() == COUNT ) {
                        continue;
                    }

                    lines = based_on_m3;
                }

                list_of_items = argument;
            }

        }

    }

    delete n;
    if(remove_first) {
        createRemoveErrorText(); // OS-specific.h and OS-specific.cpp
        removeTemporaryFiles();
    }

    if(toGize) {
        if(! detectingMatrix(DRAFO_CSV, list_of_items, firstLine, serialNumber, whoText) ) {
            createErrorText(error);
            return false;
        }

    }

    if(quit) {
        EditCount *ec = new EditCount();
        ec->setting(FULL_PATH_NAME, fileName, list_of_items, lines, cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText);
        if( ec->preediting() ) {
            fileName = ec->saved();
            cout << fileName << endl;
        } else {
            error = ec->inquiry();
            createErrorText(error);
            return false;
        }

        delete ec;
    }

    if(whoText) {
        ;
    } else {
        whoText = destroyWhoText;
    }

// Reading two test lines
    string secondLine = EMPTY;
    string whoTextLine1 = EMPTY;
    ifstream test( fileName.c_str() );
    if( test.fail() ) {
        error = "e12: ifstream test( " + fileName + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    if( test.getline(c, FILE_NAME_SIZE) ) {
        delete p;
        p = new string(c);
        whoTextLine1 = *p;
    } else {
        error = "e13(Line-1): ifstream test( " + fileName + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    if( test.getline(c, FILE_NAME_SIZE) ) {
        delete p;
        p = new string(c);
        secondLine = *p;
    } else {
        error = "e14(Line-2): ifstream test( " + fileName + CLOSE_BRACKET;
        createErrorText(error);
        return false;
    }

    delete p;

    gc->csv = csv;
    gc->cell_5 = cell_5;
    gc->firstLine = firstLine;
    gc->noSplitting = noSplitting;
    gc->serialNumber = serialNumber;
    gc->ticketForm = ticketForm;
    gc->whoText = whoText;

    gc->lines = lines;
    gc->rowCount = rowCount;

    gc->fileName = fileName;
    gc->list_of_items = list_of_items;
    gc->secondLine = secondLine;
    gc->textName = textName;
    gc->whoTextLine1 = whoTextLine1;

    int result = quit ? false : true;
    return result;
}

bool readingToProduceWhoText(std::string & fileName) {
    using namespace std;

// Reading the file to produce WHO_TEXT
    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        error = "e22: ifstream in( " + fileName + CLOSE_BRACKET;
        return false;
    }

    char c[FILE_NAME_SIZE];
    stringstream os;
    while( in.getline(c, FILE_NAME_SIZE) ) {
        os << c << NEW_LINE;
    }

    string s = os.str();
    ofstream who_text(WHO_TEXT);
    who_text << s << endl;
    return true;
}

bool removeTemporaryFiles() {
    using namespace std;

    char c[FILE_NAME_SIZE];
    ifstream in(REMOVE_ERROR_TEXT);
    if( in.fail() ) {
        return false;
    }

    while( in.getline(c, FILE_NAME_SIZE) ) {
        if( strcmp(c, WHO_TEXT) ) { // Do not remove WHO_TEXT.
            if( strcmp(c, TABULATE_TEXT) ) { // Do not remove TABULATE_TEXT.
                remove(c);
            }

        }

    }

    return true;
}

int stringToInteger(std::string & s) {
    using namespace std;

    int value;
    stringstream ss(s);
    ss >> value;
    return value;
}

NAMES driveDirectoryBase(std::string & s) {
    using namespace std;

    const string EMPTY = "";
    const string SLASH = "/";
    const string YEN = "\\";
    int firstTrace, trace, w;
    int s_length = s.length();
    string c;

    NAMES part, undivided;
    part.name[0] = EMPTY; part.name[1] = EMPTY; part.name[2] = EMPTY; part.name[3] = EMPTY;
    undivided.name[0] = EMPTY; undivided.name[1] = EMPTY; undivided.name[2] = EMPTY; undivided.name[3] = EMPTY;

    part.name[0] = s; // s.length > 0; in other words, part.name[0].length > undivided.name[0].length

// s is divided into three parts: drive name, directory name, and base name.
    int k = 0;
    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == YEN) {
            part.separator = YEN;
            break;
        } else if(c == SLASH) {
            part.separator = SLASH;
            break;
        }

    }

    if(k == s_length) { // Neither YEN nor SLASH has been found.
        return undivided;
    } else {
        w = k + 1;
        part.name[1] = s.substr(0, w); // C:\ for example
        trace = ++k;
        firstTrace = trace;
    }

    for( ; k < s_length; ++k) {
        c = s.substr(k, 1);
        if(c == part.separator) {
            trace = ++k;
        }

    }

    w = trace - firstTrace;
    part.name[2] = s.substr(firstTrace, w);
    part.name[3] = s.substr(trace); // manage.txt for example
    return part;
}

UnbrokenLine::UnbrokenLine(int h): GAP_LINES(" lines") { // gizePage.h
    using namespace std;

    howMany = h;
    n = 0;
    int q;
    stringstream os;
    os << howMany << GAP_LINES;
    ml = os.str();

    switch(howMany) {
    case 0:
        ml = ml.substr(0, 1);
        break;
    case 1:
/*
0123456
8 lines
*/
        q = ml.rfind("s");
        if(q >= 0) {
            ml = ml.substr(0, q);
        }

        break;
    default:
        break;
    }

}

void createErrorText(std::string & messages) {
    using namespace std;

    ofstream file(ERROR_TEXT);
    file << messages << endl;
}

void guide(bool comments) {
    using namespace std;

    if(comments) {
        cerr << "gize Version " << VERSION << "\n" << endl
            << "gize who.txt -1-  # Remove Line-1. " << endl
            << "gize who.txt -c8  # Read who.txt and write if 8 lines are unbroken. " << endl
            << "gize who.txt -e exclude.txt # Exclude every nurupo resu. " << endl
            << "gize who.txt -e-  # Do not edit who.txt " << endl
            << "gize who.txt -f   # FREE is expressed as **. " << endl
            << "gize who.txt -i   # Read who.txt that includes only two lines. " << endl
            << "gize who.txt -o   # Overwrite who.txt " << endl
            << "gize who.txt -q   # Quit before finding. " << endl
            << "gize who.txt -r-  # Do not remove temporary files. " << endl
            << "gize who.txt -s-  # Do not split date lines. " << endl
            << "gize who.txt -t   # Each 3 x 3 matrix is treated as a triplet. " << endl
            << "gize who.txt -to- # Do not automatically overwrite who.txt " << endl
            << "gize -V           # version " << endl
            << "gize -VC          # version with comments " << endl;
    } else {
        cerr << "gize Version " << VERSION << "\n" << endl
            << "gize who.txt -1-  " << endl
            << "gize who.txt -c8  " << endl
            << "gize who.txt -e exclude.txt " << endl
            << "gize who.txt -e-  " << endl
            << "gize who.txt -f   " << endl
            << "gize who.txt -i   " << endl
            << "gize who.txt -o   " << endl
            << "gize who.txt -q   " << endl
            << "gize who.txt -r-  " << endl
            << "gize who.txt -s-  " << endl
            << "gize who.txt -t   " << endl
            << "gize who.txt -to- " << endl
            << "gize -V           " << endl 
            << "gize -VC          " << endl;
    }

}

int main(int argc, char *argv[])
{
    using namespace std;

    stringstream os;
    for(int i = 0; i < argc; ++i) {
        os << argv[i] << GAP;
    }

    std::string command = os.str();
    if( readFilesBeforehand(command) ) {
        gc->quit = false;
    } else {
        return 0;
    }

    if(gc->onlyTwo) {
        GizeMask *gm = new GizeMask(lines, cell_5, noSplitting, serialNumber, whoText);
        gm->twoMatrices(gc->secondLine, gc->whoTextLine1);
        gm->unbrokenLines();
        delete gm;
    } else {
        EditCount *ec = new EditCount();
        ec->setting(FULL_PATH_NAME, fileName, list_of_items, lines, cell_5, csv, firstLine, noSplitting, preedit, gc->quit, serialNumber, ticketForm, whoText);
        if( ec->editCount() ) {
            string textName = ec->saved();
            cout << textName << endl;
        } else {
            error = ec->inquiry();
            createErrorText(error);
            return ERROR_CODE;
        }

        delete ec;
    }

    return 0;
}
