#ifndef GIZE_PAGE_H
#define GIZE_PAGE_H

#pragma warn -8004 // Borland C++ 5.5.1 for Win32

#define VERSION 1.14
#define BALL_COUNT 40
#define BUFFER_SIZE 384
#define CELL_COUNT 9
#define COLUMN_COUNT 7
#define COMMAND_PARAMETER_ARRAY_SIZE 64
#define CSV_LINE_COUNT 5000
#define DRAW_ARRAY_SIZE 12
#define HELP_FILE_NAME "gize.pdf"
#define KANA_KUTEN 0xA1
#define MANAGE_TEXT "manage.txt"
#define MANAGE_TEXT_LINE_COUNT 12
#define MASK_COUNT 8
#define TABULATE_TEXT "tabulate.txt"
#define TO_BUFFER_SIZE 384
#define WHO_TEXT "who.txt"
#include <fstream>
#include <iostream>
#include <map>
#include <queue>
#include <sstream>
#include "Dividing.h" // <vector>
#include "Numbered.h"
#include "OS-specific.h"
#include "TimeName.h"

typedef std::map<std::string, std::string> SIMILAR;

typedef struct GIZE_CODE GIZE_CODE;
struct GIZE_CODE {
    bool cell_5, csv, firstLine, noSplitting, onlyTwo, preedit, quit, serialNumber, ticketForm, toGize, whoText;
    int lines, rowCount;
    std::string fileName, FULL_PATH_NAME, list_of_items, secondLine, textName, whoTextLine1;
    std::string a[DRAW_ARRAY_SIZE];
    std::string draw[DRAW_ARRAY_SIZE];
};

typedef struct NAMES NAMES;
struct NAMES {
    std::string name[4];
    std::string separator;
};

class UnbrokenLine {
    const std::string GAP_LINES;

    int howMany, n;
    int mask_index[MASK_COUNT];
    std::string ml, messages;

public:
    int index(int i) const {
        return mask_index[i];
    }

    int registering(int m) {
        mask_index[n++] = m;
        return n;
    }

    int unbrokenCount() const {
        return howMany;
    }

    std::string howManyLines() const {
        return ml;
    }

    std::string secondLineExtra() const {
        return messages;
    }

    void remarks(std::string & m) {
        messages = m;
    }

    UnbrokenLine(int h); // gizeMain.cpp
};

enum PAGE {GIZE_TRIPLET, CSV, MATRIX};

int stringToInteger(std::string & s);
NAMES driveDirectoryBase(std::string & s);
void createErrorText(std::string & messages);

#endif // GIZE_PAGE_H
